# Class BootstrapMethods

java.lang.Object
org.apache.bcel.classfile.Attribute
org.apache.bcel.classfile.BootstrapMethods

All Implemented Interfaces:
  `Cloneable, Iterable<BootstrapMethod>, Node`

public class BootstrapMethods extends Attribute implements Iterable<BootstrapMethod>
This class represents a BootstrapMethods attribute.

Since:
  6.0
See Also:
  - The class File Format : The BootstrapMethods Attribute

- ## Field Summary

  ### Fields inherited from class Attribute

  `constant_pool, EMPTY_ARRAY, length, name_index, tag`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `BootstrapMethods(int nameIndex, int length, BootstrapMethod[] bootstrapMethods, ConstantPool constantPool)`
  Constructs a BootstrapMethods attribute.
  `BootstrapMethods(BootstrapMethods c)`
  Initialize from another object.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `accept(Visitor v)`
  Accepts a visitor.
  `BootstrapMethods`
  `copy(ConstantPool constantPool)`
  Creates a deep copy of this attribute.
  `final void`
  `dump(DataOutputStream file)`
  Dumps bootstrap methods attribute to file stream in binary format.
  `final BootstrapMethod[]`
  `getBootstrapMethods()`
  Gets the array of bootstrap method records.
  `Iterator<BootstrapMethod>`
  `iterator()`
  `final void`
  `setBootstrapMethods(BootstrapMethod[] bootstrapMethods)`
  Sets the bootstrap methods.
  `final String`
  `toString()`

  ### Methods inherited from class Attribute

  `addAttributeReader, addAttributeReader, clone, getConstantPool, getLength, getName, getNameIndex, getTag, println, readAttribute, readAttribute, removeAttributeReader, setConstantPool, setLength, setNameIndex`

  ### Methods inherited from class Object

  `equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface Iterable

  `forEach, spliterator`

- ## Constructor Details

  - ### BootstrapMethods

    public BootstrapMethods(BootstrapMethods c)
    Initialize from another object. Note that both objects use the same references (shallow copy). Use clone() for a physical copy.
    Parameters:
      `c` - Source to copy.

  - ### BootstrapMethods

    public BootstrapMethods(int nameIndex, int length, BootstrapMethod[] bootstrapMethods, ConstantPool constantPool)
    Constructs a BootstrapMethods attribute.
    Parameters:
      `nameIndex` - Index in constant pool to CONSTANT_Utf8.
      `length` - Content length in bytes.
      `bootstrapMethods` - array of bootstrap methods.
      `constantPool` - Array of constants.

- ## Method Details

  - ### accept

    public void accept(Visitor v)
    Accepts a visitor.
    Specified by:
      `accept` in interface `Node`
    Specified by:
      `accept` in class `Attribute`
    Parameters:
      `v` - Visitor object.

  - ### copy

    public BootstrapMethods copy(ConstantPool constantPool)
    Creates a deep copy of this attribute.
    Specified by:
      `copy` in class `Attribute`
    Parameters:
      `constantPool` - the constant pool.
    Returns:
      deep copy of this attribute.

  - ### dump

    public final void dump(DataOutputStream file) throws IOException
    Dumps bootstrap methods attribute to file stream in binary format.
    Overrides:
      `dump` in class `Attribute`
    Parameters:
      `file` - Output file stream.
    Throws:
      `IOException` - if an I/O error occurs.

  - ### getBootstrapMethods

    public final BootstrapMethod[] getBootstrapMethods()
    Gets the array of bootstrap method records.
    Returns:
      array of bootstrap method records.

  - ### iterator

    public Iterator<BootstrapMethod> iterator()
    Specified by:
      `iterator` in interface `Iterable<BootstrapMethod>`

  - ### setBootstrapMethods

    public final void setBootstrapMethods(BootstrapMethod[] bootstrapMethods)
    Sets the bootstrap methods.
    Parameters:
      `bootstrapMethods` - the array of bootstrap methods.

  - ### toString

    public final String toString()
    Overrides:
      `toString` in class `Attribute`
    Returns:
      String representation.